'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withNotify;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactDisplayName = require('react-display-name');

var _reactDisplayName2 = _interopRequireDefault(_reactDisplayName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/jsx-filename-extension */
function withNotify() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var Trigger = config.trigger,
      onSuccess = config.onSuccess,
      onError = config.onError,
      _config$sourceStateNa = config.sourceStateName,
      sourceStateName = _config$sourceStateNa === undefined ? 'source' : _config$sourceStateNa,
      _config$disbleErrorLo = config.disbleErrorLogger,
      disbleErrorLogger = _config$disbleErrorLo === undefined ? false : _config$disbleErrorLo,
      _config$errorTexts = config.errorTexts,
      errorTexts = _config$errorTexts === undefined ? {} : _config$errorTexts,
      filter = config.filter;

  return function (TargetComponent) {
    var WithNotify = function (_Component) {
      _inherits(WithNotify, _Component);

      function WithNotify() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WithNotify);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WithNotify.__proto__ || Object.getPrototypeOf(WithNotify)).call.apply(_ref, [this].concat(args))), _this), _this._trigger = null, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(WithNotify, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(_ref2) {
          var _ref2$sourceStateName = _ref2[sourceStateName],
              nextIsPending = _ref2$sourceStateName.isPending,
              nextErrors = _ref2$sourceStateName.errors,
              nextResult = _ref2$sourceStateName.result;
          var _props$sourceStateNam = this.props[sourceStateName],
              isPending = _props$sourceStateNam.isPending,
              result = _props$sourceStateNam.result;

          if (filter && !filter(result, nextResult)) {
            return;
          }
          if (isPending && !nextIsPending) {
            if (nextErrors.length) {
              onError(this._trigger, nextErrors);
              if (nextErrors.length && !disbleErrorLogger && (typeof console === 'undefined' ? 'undefined' : _typeof(console)) === 'object' && console.error) {
                nextErrors.forEach(function (error) {
                  if (!errorTexts[error.message]) {
                    console.error(sourceStateName + ' error:', error.stack || error);
                  }
                });
              }
            } else {
              onSuccess(this._trigger);
            }
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _this2 = this;

          var passThroughProps = _objectWithoutProperties(this.props, []);

          return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(TargetComponent, passThroughProps),
            Trigger && _react2.default.createElement(Trigger, {
              ref: function ref(node) {
                _this2._trigger = node;
              }
            })
          );
        }
      }]);

      return WithNotify;
    }(_react.Component);

    (0, _hoistNonReactStatics2.default)(WithNotify, TargetComponent);
    WithNotify.displayName = 'WithNotify(' + (0, _reactDisplayName2.default)(TargetComponent) + ')';
    return WithNotify;
  };
}
/* eslint-enable react/jsx-filename-extension */

module.exports = exports['default'];
//# sourceMappingURL=withNotify.js.map